typealias Point = Pair<Long, Long>

fun main() {

    fun parseLine(line: String): Point {
        val (x, y) = line.split(":")[1].trim().split(",").map { it.split("""[+=]""".toRegex())[1] }
        return x.toLong() to y.toLong()
    }

    fun optimize(machine: List<String>): Long {

        var (a, b, c) = machine.map { parseLine(it) }
        c = c.first + 10000000000000 to c.second + 10000000000000
        parseLine(machine[2])

        val det = (a.first * b.second - a.second * b.first)
        val detA = c.first * b.second - c.second * b.first
        val detB = a.first * c.second - a.second * c.first
        if (detA % det == 0L && detB % det == 0L)
            return 3L*detA/det + detB/det
        return 0L
    }

    fun part1(input: List<String>): Long {
        val machines = input.filterNot { it.isEmpty() }.chunked(3)
        return machines.sumOf { optimize(it) }
    }

    val input = readInput("Day13")
    part1(input).println()
}